-- name: ! SM64E\\#33FF57\\xCoop\\#5733FF\\ Rand\\#FF33A1\\omize\\#33A1FF\\r V2.5 !
-- description: This mod is based off of the randomizer hack which randomizes object location, levels, music and more!

--! CHANGE THE SEED HERE !

gGlobalSyncTable.seed = 8008135 --! CHANGE THIS

for i = 0, MAX_PLAYERS - 1 do
    gPlayerSyncTable[i].entryCourse = nil
    gPlayerSyncTable[i].entryLevel = nil
end

local obj_get_next_with_same_behavior_id,get_id_from_behavior,collision_find_surface_on_ray,ipairs,find_floor_height,bhv_init_room,cur_obj_set_home_once,
      obj_get_first,obj_get_next,set_background_music,warp_to_level,set_override_skybox,
      nearest_mario_state_to_object,obj_check_hitbox_overlap,spawn_non_sync_object,obj_set_billboard,obj_mark_for_deletion,obj_set_pos,obj_scale,obj_set_angle,
      hook_behavior,obj_get_first_with_behavior_id, hook_event
      =
      obj_get_next_with_same_behavior_id,get_id_from_behavior,collision_find_surface_on_ray,ipairs,find_floor_height,bhv_init_room,cur_obj_set_home_once,
      obj_get_first,obj_get_next,set_background_music,warp_to_level,set_override_skybox,
      nearest_mario_state_to_object,obj_check_hitbox_overlap,spawn_non_sync_object,obj_set_billboard,obj_mark_for_deletion,obj_set_pos,obj_scale,obj_set_angle,
      hook_behavior,obj_get_first_with_behavior_id, hook_event

gLevelValues.disableActs = true
gLevelValues.showStarNumber = true

oldSeed = gGlobalSyncTable.seed

E_MODEL_TRANS_PIPE = smlua_model_util_get_id("trans_pipe_geo")

gGlobalSyncTable.starRequirement = -54170
gGlobalSyncTable.randomizeLvl = true
gGlobalSyncTable.randomizeObj = true

function for_each_object_with_behavior(behavior, func_f) --* function by isaac
    local obj = obj_get_first_with_behavior_id(behavior)
    while obj ~= nil do
        func_f(obj)
        obj = obj_get_next_with_same_behavior_id(obj)
    end
end

local config = { --* there HAS to be a better way to do this..
    groundedObjects = {
        [id_bhvWarpPipe] = true,
        [id_bhvRockSolid] = true,
        [id_bhvMrI] = true,
        [id_bhvPiranhaPlant] = true,
        [id_bhvPushableMetalBox] = true,
        [id_bhvBreakableBox] = true,
        [id_bhvCoinFormation] = true,
        [id_bhvFallingPillar] = true,
        [id_bhvPillarBase] = true,
        [id_bhvBobomb] = true,
        [id_bhvGoomba] = true,
        [id_bhvWoodenPost] = true,
        [id_bhvMessagePanel] = true,
        [id_bhvToadMessage] = true,
        [id_bhvWhompKingBoss] = true,
        [id_bhvSmallWhomp] = true,
        [id_bhvThwomp] = true,
        [id_bhvThwomp2] = true,
        [id_bhvTree] = true,
        [id_bhvKickableBoard] = true,
    },
    skipBehaviors = {
        [id_bhvWaterLevelDiamond] = true,
        [id_bhvDoor] = true,
        [id_bhvUkikiCageStar] = true,
        [id_bhvUkikiCage] = true,
        [id_bhvDddWarp] = true,
        [id_bhvBigBoulderGenerator] = true,
        [id_bhvBigBoulder] = true,
        [id_bhvTreasureChestTop] = true,
        [id_bhvStarDoor] = true,
        [id_bhvDoorWarp] = true,
        [id_bhvAirborneWarp] = true,
        [id_bhvSpinAirborneWarp] = true,
        [id_bhvSnowmansHead] = true,
        [id_bhvSnowmansBodyCheckpoint] = true,
        [id_bhvSnowmansBottom] = true,
        [id_bhvJrbFloatingBox] = true,
        [id_bhvSwingPlatform] = true,
        [id_bhvWarp] = true,
        [id_bhvControllablePlatform] = true,
        [id_bhvPurpleSwitchHiddenBoxes] = true,
        [id_bhvHiddenObject] = true,
        [id_bhvPitBowlingBall] = true,
        [id_bhvBobBowlingBallSpawner] = true,
        [id_bhvThiBowlingBallSpawner] = true,
        [id_bhvTtmBowlingBallSpawner] = true,
        [id_bhvFreeBowlingBall] = true,
        [id_bhvKoopaRaceEndpoint] = true,
        [id_bhvKoopa] = true,
        [id_bhvOpenableCageDoor] = true,
        [id_bhvWaterLevelPillar] = true,
        [id_bhvCannon] = true,
        [id_bhvCannonClosed] = true,
        [id_bhvCannonBarrel] = true,
        [id_bhvCannonBarrelBubbles] = true,
        [id_bhvCannon] = true,
        [id_bhvCannonBarrel] = true,
        [id_bhvDDDPole] = true,
        [id_bhvSeesawPlatform] = true,
        [id_bhvChainChomp] = true,
        [id_bhvChainChompChainPart] = true,
        [id_bhvChainChompGate] = true,
        [id_bhvCheckerboardPlatformSub] = true,
        [id_bhvGiantPole] = true,
        [id_bhvHmcElevatorPlatform] = true,
        [id_bhvAnotherElavator] = true,
        [id_bhvTower] = true,
        [id_bhvTowerPlatformGroup] = true,
        [id_bhvTowerDoor] = true,
        [id_bhvDonutPlatform] = true,
        [id_bhvDonutPlatformSpawner] = true,
        [id_bhvBbhTiltingTrapPlatform] = true,
        [id_bhvPoleGrabbing] = true,
        [id_bhvDddMovingPole] = true,
        [id_bhvBowsersSub] = true,
        [id_bhvBowserBomb] = true,
        [id_bhvBowser] = true,
        [id_bhvCastleFloorTrap] = true,
        [id_bhvCastleFlagWaving] = true,
        [id_bhvFallingBowserPlatform] = true,
        [id_bhvTiltingBowserLavaPlatform] = true,
        [id_bhvWaterBombCannon] = true,
        [id_bhvMerryGoRound] = true,
        [id_bhvMerryGoRoundBigBoo] = true,
        [id_bhvMerryGoRoundBooManager] = true,
        [id_bhvClockHourHand] = true,
        [id_bhvClockMinuteHand] = true,
        [id_bhvDecorativePendulum] = true,
        [id_bhvDddMovingPole] = true,
        [id_bhvPurpleSwitchHiddenBoxes] = true,
        [id_bhvCapSwitchBase] = true,
        [id_bhvCapSwitch] = true,
        [id_bhvHiddenBlueCoin] = true,
        [id_bhvBlueCoinSwitch] = true,
        [id_bhvBigSnowmanWhole] = true,
        [id_bhvFloorSwitchHiddenObjects] = true,
        [id_bhvFloorSwitchHardcodedModel] = true,
        [id_bhvFloorSwitchGrills] = true,
        [id_bhvFloorSwitchAnimatesObject] = true,
        [id_bhvHiddenStaircaseStep] = true,
        [id_bhvFerrisWheelAxle] = true,
        [id_bhvFerrisWheelPlatform] = true,
        [id_bhvPlatformOnTrack] = true,
        [id_bhvTTCRotatingSolid] = true,
        [id_bhvTTC2DRotator] = true,
        [id_bhvTTCCog]       = true,
        [id_bhvTTCElevator]  = true,
        [id_bhvTTCMovingBar] = true,
        [id_bhvTTCPendulum]  = true,
        [id_bhvTTCPitBlock]  = true,
        [id_bhvTTCRotatingSolid] = true,
        [id_bhvHauntedBookshelfManager] = true,
        [id_bhvHauntedBookshelf] = true,
        [id_bhvTTCSpinner]   = true,
        [id_bhvTTCTreadmill] = true,
        [id_bhvLargeBomp] = true,
        [id_bhvSmallBomp] = true,
        [id_bhvWfBreakableWallLeft] = true,
        [id_bhvRacingPenguin] = true,
        [id_bhvWfBreakableWallRight] = true,
        [id_bhvWfRotatingWoodenPlatform] = true,
        [id_bhvRotatingPlatform] = true,
        [id_bhvSlidingPlatform2] = true,
        [id_bhvCoffin] = true,
        [id_bhvCoffinSpawner] = true,
        [id_bhvWfSlidingPlatform] = true,
        [id_bhvWfSlidingTowerPlatform] = true,
        [id_bhvLllSinkingRockBlock] = true,
        [id_bhvLllHexagonalMesh] = true,
        [id_bhvStaticCheckeredPlatform] = true,
        [id_bhvCheckerboardElevatorGroup] = true,
        [id_bhvSmallBomp] = true,
        [id_bhvOctagonalPlatformRotating] = true,
        [id_bhvFloorSwitchAnimatesObject] = true,
        [id_bhvPyramidTop] = true,
        [id_bhvPyramidPillarTouchDetector] = true,
        [id_bhvJetStream] = true,
        [id_bhvJetStreamRingSpawner] = true,
        [id_bhvJetStreamWaterRing] = true,
        [id_bhvPyramidElevator] = true,
        [id_bhvToxBox] = true,
        [id_bhvAnimatesOnFloorSwitchPress] = true,
        [id_bhvTumblingBridgePlatform] = true,
        [id_bhvBbhTumblingBridge] = true,
        [id_bhvFadingWarp] = true,
        [id_bhvSunkenShipPart] = true,
        [id_bhvInSunkenShip2] = true,
        [id_bhvShipPart3] = true,
        [id_bhvInSunkenShip] = true,
        [id_bhvInSunkenShip3] = true,
        [id_bhvSunkenShipPart2] = true,
        [id_bhvSunkenShipSetRotation] = true,
        [id_bhvOpenableGrill] = true,
        [id_bhvUnagi] = true,
        [id_bhvLllBowserPuzzle] = true,
        [id_bhvLllDrawbridge] = true,
        [id_bhvLllDrawbridgeSpawner] = true,
        [id_bhvLllRollingLog] = true,
        [id_bhvLllRotatingHexagonalPlatform] = true,
        [id_bhvLllRotatingHexagonalRing] = true,
        [id_bhvLllRotatingBlockWithFireBars] = true,
        [id_bhvLllSinkingRectangularPlatform] = true,
        [id_bhvLllTiltingInvertedPyramid] = true,
        [id_bhvLllSinkingSquarePlatforms] = true,
        [id_bhvLllMovingOctagonalMeshPlatform] = true,
        [id_bhvLllWoodPiece] = true,
        [id_bhvLllFloatingWoodBridge] = true,
        [id_bhvTtmRollingLog] = true,
        [id_bhvWfSolidTowerPlatform] = true,
        [id_bhvSquarishPathMoving] = true,
        [id_bhvSquarishPathParent] = true,
        [id_bhvWfSlidingTowerPlatform] = true,
        [id_bhvWfElevatorTowerPlatform] = true,
        [id_bhvWdwExpressElevator] = true,
        [id_bhvBitfsSinkingCagePlatform] = true,
        [id_bhvBitfsSinkingPlatforms] = true,
        [id_bhvMeshElevator] = true,
        [id_bhvSquishablePlatform] = true,
        [id_bhvWfTumblingBridge] = true,
        [id_bhvSLWalkingPenguin] = true,
        [id_bhvBulletBill] = true,
        [id_bhvBulletBillCannon] = true,
        [id_bhvSnowMoundSpawn] = true,
        [id_bhvWdwExpressElevatorPlatform] = true,
        [id_bhvStaticObject] = true, --* mostly the extra model geometry found in levels like CCM or WF
    },
}

local sPaintingToVanillaTexture = {
    [gPaintingValues.bob_painting.id] = {
        top = "inside_castle_seg7_texture_0700A800",
        bottom = "inside_castle_seg7_texture_0700B800"
    },
    [gPaintingValues.wf_painting.id] = {
        top = "inside_castle_seg7_texture_0700E800",
        bottom = "inside_castle_seg7_texture_0700F800"
    },
    [gPaintingValues.jrb_painting.id] = {
        top = "inside_castle_seg7_texture_07010800",
        bottom = "inside_castle_seg7_texture_07011800"
    },
    [gPaintingValues.ccm_painting.id] = {
        top = "inside_castle_seg7_texture_0700C800",
        bottom = "inside_castle_seg7_texture_0700D800"
    },
    [gPaintingValues.hmc_painting.id] = {            --! horizontal
        top = "inside_castle_seg7_texture_07016800", --* env map
        bottom = "inside_castle_seg7_texture_07016800",
    },
    [gPaintingValues.lll_painting.id] = {
        top = "inside_castle_seg7_texture_07013800",
        bottom = "inside_castle_seg7_texture_07012800"
    },
    [gPaintingValues.ssl_painting.id] = {
        top = "inside_castle_seg7_texture_07014800",
        bottom = "inside_castle_seg7_texture_07015800"
    },
    [gPaintingValues.ddd_painting.id] = {
        top = "inside_castle_seg7_texture_07017000", --* env map
        bottom = "inside_castle_seg7_texture_07017000",
    },
    [gPaintingValues.ssl_painting.id] = {
        top = "inside_castle_seg7_texture_07014800",
        bottom = "inside_castle_seg7_texture_07015800"
    },
    [gPaintingValues.wdw_painting.id] = {
        top = "inside_castle_seg7_texture_07017800",
        bottom = "inside_castle_seg7_texture_07018800"
    },
    [gPaintingValues.sl_painting.id] = {
        top = "inside_castle_seg7_texture_0701F800",
        bottom = "inside_castle_seg7_texture_07020800"
    },
    [gPaintingValues.ttm_painting.id] = {
        top = "inside_castle_seg7_texture_0701B800",
        bottom = "inside_castle_seg7_texture_0701C800"
    },
    [gPaintingValues.thi_tiny_painting.id] = {
        top = "inside_castle_seg7_texture_07019800",
        bottom = "inside_castle_seg7_texture_0701A800"
    },
    [gPaintingValues.thi_huge_painting.id] = {
        top = "inside_castle_seg7_texture_07019800",
        bottom = "inside_castle_seg7_texture_0701A800"
    },
    [gPaintingValues.ttc_painting.id] = {
        top = "inside_castle_seg7_texture_0701D800",
        bottom = "inside_castle_seg7_texture_0701E800"
    },
}

local levelToPainting = {
    [LEVEL_BOB] = {top = "bob_top", bottom = "bob_bottom"},
    [LEVEL_WF] = {top = "wf_top", bottom = "wf_bottom"},
    [LEVEL_JRB] = {top = "jrb_top", bottom = "jrb_bottom"},
    [LEVEL_CCM] = {top = "ccm_top", bottom = "ccm_bottom"},
    [LEVEL_BBH] = {top = "bbh_top", bottom = "bbh_bottom"},
    [LEVEL_HMC] = {top = "hmc_top", bottom = "hmc_bottom"},
    [LEVEL_LLL] = {top = "lll_top", bottom = "lll_bottom"},
    [LEVEL_SSL] = {top = "ssl_top", bottom = "ssl_bottom"},
    [LEVEL_DDD] = {top = "ddd_top", bottom = "ddd_bottom"},
    [LEVEL_SL] = {top = "sl_top", bottom = "sl_bottom"},
    [LEVEL_WDW] = {top = "wdw_top", bottom = "wdw_bottom"},
    [LEVEL_TTM] = {top = "ttm_top", bottom = "ttm_bottom"},
    [LEVEL_THI] = {top = "thi_top", bottom = "thi_bottom"},
    [LEVEL_TTC] = {top = "ttc_top", bottom = "ttc_bottom"},
    [LEVEL_RR] = {top = "rr_top", bottom = "rr_bottom"},
    [LEVEL_PSS] = {top = "pss_top", bottom = "pss_bottom"},
    [LEVEL_SA] = {top = "sa_top", bottom = "sa_bottom"},
    [LEVEL_WMOTR] = {top = "sl_top", bottom = "sl_bottom"},
    [LEVEL_TOTWC] = {top = "totwc_top", bottom = "totwc_bottom"},
    [LEVEL_COTMC] = {top = "cotmc_top", bottom = "cotmc_bottom"},
    [LEVEL_VCUTM] = {top = "vcutm_top", bottom = "vcutm_bottom"},
    [LEVEL_BITDW] = {top = "bitdw_top", bottom = "bitdw_bottom"},
    [LEVEL_BITFS] = {top = "bitfs_top", bottom = "bitfs_bottom"},
}

local unshuffledDialogTable = {}

for i = DIALOG_000, DIALOG_168 do
    unshuffledDialogTable[i] = i
end

local unshuffledLevelTable = {
    [COURSE_BOB]   = LEVEL_BOB,
    [COURSE_WF]    = LEVEL_WF,
    [COURSE_JRB]   = LEVEL_JRB,
    [COURSE_CCM]   = LEVEL_CCM,
    [COURSE_BBH]   = LEVEL_BBH,
    [COURSE_HMC]   = LEVEL_HMC,
    [COURSE_LLL]   = LEVEL_LLL,
    [COURSE_SSL]   = LEVEL_SSL,
    [COURSE_DDD]   = LEVEL_DDD,
    [COURSE_SL]    = LEVEL_SL,
    [COURSE_WDW]   = LEVEL_WDW,
    [COURSE_TTM]   = LEVEL_TTM,
    [COURSE_THI]   = LEVEL_THI,
    [COURSE_TTC]   = LEVEL_TTC,
    [COURSE_RR]    = LEVEL_RR,
    [COURSE_PSS]   = LEVEL_PSS,
    [COURSE_SA]    = LEVEL_SA,
    [COURSE_WMOTR] = LEVEL_WMOTR,
    [COURSE_TOTWC] = LEVEL_TOTWC,
    [COURSE_COTMC] = LEVEL_COTMC,
    [COURSE_VCUTM] = LEVEL_VCUTM,
    [COURSE_BITDW] = LEVEL_BITDW,
    [COURSE_BITFS] = LEVEL_BITFS,
}

local sFloorsToBowserLevels = {
    {COURSE_BOB, COURSE_WF, COURSE_JRB, COURSE_CCM, COURSE_BBH, COURSE_PSS, COURSE_SA, COURSE_TOTWC, COURSE_BITDW, bowser = LEVEL_BITDW},
    {COURSE_SSL, COURSE_LLL, COURSE_HMC, COURSE_DDD, COURSE_BITFS, COURSE_VCUTM, bowser = LEVEL_BITFS},
}

local musicTable = {
    SEQ_LEVEL_GRASS,
    SEQ_LEVEL_SPOOKY,
    SEQ_LEVEL_HOT,
    SEQ_LEVEL_BOSS_KOOPA,
    SEQ_LEVEL_BOSS_KOOPA_FINAL,
    SEQ_LEVEL_SNOW,
    SEQ_LEVEL_WATER,
    SEQ_LEVEL_SLIDE,
    SEQ_LEVEL_INSIDE_CASTLE,
    SEQ_LEVEL_KOOPA_ROAD,
    SEQ_LEVEL_UNDERGROUND,
    SEQ_MENU_FILE_SELECT,
    SEQ_MENU_TITLE_SCREEN,
    SEQ_EVENT_MERRY_GO_ROUND,
    SEQ_EVENT_PIRANHA_PLANT,
    SEQ_EVENT_POWERUP,
    SEQ_EVENT_METAL_CAP,
    SEQ_EVENT_ENDLESS_STAIRS,
    SEQ_EVENT_CUTSCENE_CREDITS,
    SEQ_EVENT_BOSS,
}

local skyboxTable = {
    BACKGROUND_OCEAN_SKY,
    BACKGROUND_ABOVE_CLOUDS,
    BACKGROUND_BELOW_CLOUDS,
    BACKGROUND_DESERT,
    BACKGROUND_FLAMING_SKY,
    BACKGROUND_PURPLE_SKY,
    BACKGROUND_GREEN_SKY,
    BACKGROUND_HAUNTED,
    BACKGROUND_SNOW_MOUNTAINS,
}

local invalidSurfaces = {
    [SURFACE_INSTANT_QUICKSAND] = true,
    [SURFACE_INTANGIBLE] = true,
    [SURFACE_DEATH_PLANE] = true,
    [SURFACE_BURNING] = true,
    [SURFACE_VERTICAL_WIND] = true,
    [SURFACE_INSTANT_MOVING_QUICKSAND] = true,
    [SURFACE_INSTANT_WARP_1B] = true,
    [SURFACE_INSTANT_WARP_1C] = true,
    [SURFACE_INSTANT_WARP_1D] = true,
    [SURFACE_INSTANT_WARP_1E] = true,
    [SURFACE_WARP] = true,
}

local levelsToSkip = {
    [LEVEL_BOWSER_1] = true,
    [LEVEL_BOWSER_2] = true,
    [LEVEL_BOWSER_3] = true,
    [LEVEL_BITS] = true,
    [LEVEL_CASTLE_GROUNDS] = true,
    [LEVEL_CASTLE_COURTYARD] = true,
    [LEVEL_CASTLE] = true,
    [LEVEL_ENDING] = true,
}

function shuffle_table(t, seed)
    local keys = {}
    local values = {}

    math.randomseed(seed)

    for k, v in pairs(t) do
        table.insert(keys, k)
        table.insert(values, v)
    end

    for i = #values, 2, -1 do
        local j =math.random(1, i)
        values[i], values[j] = values[j], values[i]
    end

    local shuffled = {}
    for i, k in ipairs(keys) do
        shuffled[k] = values[i]
    end

    return shuffled
end

function ensure_bowser_access(levelTable, seed)
    for _, floor in ipairs(sFloorsToBowserLevels) do
        local bowserLevel = floor.bowser
        local leadsToBowser = false
        local bowserSource = nil

        for _, level in ipairs(floor) do
            if levelTable[level] == bowserLevel then
                leadsToBowser = true
                break
            end
        end

        if not leadsToBowser then
            for src, dest in pairs(levelTable) do
                if dest == bowserLevel then
                    bowserSource = src
                    break
                end
            end

            if bowserSource then
                math.randomseed(seed)
                local swapTarget = floor[math.random(1, #floor)]

                levelTable[bowserSource], levelTable[swapTarget] = levelTable[swapTarget], bowserLevel
            end
        end
    end
end

levelTable = {}
dialogTable = {}

local function applyShuffle()
    levelTable = shuffle_table(unshuffledLevelTable, gGlobalSyncTable.seed)
    ensure_bowser_access(levelTable, gGlobalSyncTable.seed)

    dialogTable = shuffle_table(unshuffledDialogTable, gGlobalSyncTable.seed)
end

applyShuffle()

local sPaintingToLevel = {
    [gPaintingValues.bob_painting.id] = COURSE_BOB,
    [gPaintingValues.wf_painting.id] = COURSE_WF,
    [gPaintingValues.jrb_painting.id] = COURSE_JRB,
    [gPaintingValues.ccm_painting.id] = COURSE_CCM,
    [gPaintingValues.lll_painting.id] = COURSE_LLL,
    [gPaintingValues.ssl_painting.id] = COURSE_SSL,
    [gPaintingValues.hmc_painting.id] = COURSE_HMC,
    [gPaintingValues.ddd_painting.id] = COURSE_DDD,
    [gPaintingValues.wdw_painting.id] = COURSE_WDW,
    [gPaintingValues.sl_painting.id] = COURSE_SL,
    [gPaintingValues.thi_huge_painting.id] = COURSE_THI,
    [gPaintingValues.thi_tiny_painting.id] = COURSE_THI,
    [gPaintingValues.ttc_painting.id] = COURSE_TTC,
}

function set_painting_texture()
    for _, painting in pairs({
        "bob_painting", "wf_painting", "ccm_painting", "jrb_painting",
        "ssl_painting", "lll_painting", "hmc_painting", "cotmc_painting",
        "ddd_painting", "wdw_painting", "ttm_painting", "ttm_slide_painting",
        "sl_painting", "thi_huge_painting", "thi_tiny_painting", "ttc_painting"
    }) do
        local p = gPaintingValues[painting]

        local newLevel = levelTable[sPaintingToLevel[p.id]] or LEVEL_BOB

        local newTexture = levelToPainting[newLevel]

        texture_override_reset(sPaintingToVanillaTexture[p.id].top)
        texture_override_reset(sPaintingToVanillaTexture[p.id].bottom)

        texture_override_set(sPaintingToVanillaTexture[p.id].top, get_texture_info(newTexture.top))
        texture_override_set(sPaintingToVanillaTexture[p.id].bottom, get_texture_info(newTexture.bottom))
    end
end

for k, v in pairs(levelTable) do
    print(k, v)
end

local objectData = {}

HACK_VANILLA = 0
HACK_STAR_ROAD = 1

local currHack = "vanilla"

for i, mod in pairs(gActiveMods) do
    if mod.enabled then
        if mod.incompatible and mod.incompatible:find("romhack") then
            djui_popup_create(mod.name.." Detected!", 1)
            currHack = mod.name:lower()
        end
    end
    if currHack == nil then
        currHack = "vanilla"
    end
end

local vanillaAvoidancePoints = {
    [LEVEL_CASTLE_GROUNDS] = {
        {area = 1, pointA = {x = 513, y = 803, z = -3668}, pointB = {x = -512, y = 6000, z = -3206}},
    },
    [LEVEL_DDD] = {
        {area = 1, pointA = {x = 3628, y = 1000, z = -401}, pointB = {x = -1771, y = -2756, z = -402}},
        {area = 2, pointA = {x = 3628, y = 1000, z = -401}, pointB = {x = -1771, y = -2756, z = -402}},
    },
}

local StarRoadAvoidancePoints = {
    [LEVEL_BOB] = {
        {area = 1, pointA = {x = 7397, y = -2495, z = -7795}, pointB = {x = -7223, y = -99999, z = 6606}},
    },
}

local avoidancePoints = {
    ["vanilla"] = vanillaAvoidancePoints,
    ["star road"] = StarRoadAvoidancePoints,
}

local function is_within_avoidance_point(level, area, position)
    if not avoidancePoints[currHack] then return false end

    local points = avoidancePoints[currHack][level]

    if not points then return false end

    for _, point in ipairs(points) do
        if point.area == area then
            local pA, pB = point.pointA, point.pointB
            if position.x >= math.min(pA.x, pB.x) and position.x <= math.max(pA.x, pB.x) and
               position.y >= math.min(pA.y, pB.y) and position.y <= math.max(pA.y, pB.y) and
               position.z >= math.min(pA.z, pB.z) and position.z <= math.max(pA.z, pB.z) then
                return true
            end
        end
    end

    return false
end

local function is_surface_valid(surface)
    if surface ~= nil and not invalidSurfaces[surface.type] and (surface.type < SURFACE_PAINTING_WARP_D3 or surface.type < SURFACE_PAINTING_WARP_FC) then
    return true end
end

local function randomize(o)
    --* don't randomize custom behaviors
    if config.skipBehaviors[get_id_from_behavior(o.behavior)] or get_id_from_behavior(o.behavior) >= id_bhv_max_count then return false end

    local originalPos = {x = o.oPosX, y = o.oPosY, z = o.oPosZ}
    objectData[o] = {originalPos = originalPos, randomized = false}

    local numRaycasts = 200
    local validHitPositions = {}
    local level = gNetworkPlayers[0].currLevelNum
    local area = gNetworkPlayers[0].currAreaIndex

    if o.oInteractType & INTERACT_TEXT ~= 0 or o.oInteractionSubtype & INT_SUBTYPE_SIGN ~= 0 or o.oInteractionSubtype & INT_SUBTYPE_NPC ~= 0 then
        o.oBehParams2ndByte = dialogTable[o.oBehParams2ndByte]
    end

    for i = 1, numRaycasts do
        local dirX = math.random(-32768, 32768)
        local dirY = math.random(-32768, 32768)
        local dirZ = math.random(-32768, 32768)

        local ray = collision_find_surface_on_ray(math.random(-8200, 8200), o.oPosY, math.random(-8200, 8200), dirX, dirY, dirZ)

        if is_surface_valid(ray.surface) then
            local normal = ray.surface.normal
            if normal.y > 0.9 then
                local hitPos = ray.hitPos
                local valid = true

                for _, prevHitPos in ipairs(validHitPositions) do
                    local distance = math.sqrt((hitPos.x - prevHitPos.x)^2 + (hitPos.y - prevHitPos.y)^2 + (hitPos.z - prevHitPos.z)^2)
                    if distance <= 500 then
                        valid = false
                        break
                    end
                end

                local distanceToOriginal = math.sqrt((hitPos.x - originalPos.x)^2 + (hitPos.y - originalPos.y)^2 + (hitPos.z - originalPos.z)^2)
                if distanceToOriginal <= 2000 then
                    valid = false
                end

                if is_within_avoidance_point(level, area, hitPos) then
                    valid = false
                end

                if valid then
                    table.insert(validHitPositions, hitPos)
                    o.oPosX = hitPos.x
                    o.oPosY = hitPos.y
                    o.oPosZ = hitPos.z
                    objectData[o].randomized = true
                end
            end
        end
    end

    if objectData[o].randomized then
        if config.groundedObjects[get_id_from_behavior(o.behavior)] then
            o.oPosY = find_floor_height(o.oPosX, o.oPosY, o.oPosZ)
        else
            o.oPosY = clamp(find_floor_height(o.oPosX, o.oPosY, o.oPosZ) + math.random(0, 800), find_floor_height(o.oPosX, o.oPosY, o.oPosZ), find_ceil_height(o.oPosX, o.oPosY, o.oPosZ))
        end
        bhv_init_room()
        cur_obj_set_home_once()
    end
end

function randomize_all_objects()
    for objList = 0, NUM_OBJ_LISTS - 1 do
        local o = obj_get_first(objList)
        while o ~= nil do
            randomize(o)
            o = obj_get_next(o)
        end
    end
end

local np0 = gNetworkPlayers[0]

local currArea  = 0
local currLevel = 0
local function on_warp()
    if currLevel ~= np0.currLevelNum or currArea ~= np0.currAreaIndex then
        currArea  = np0.currAreaIndex
        currLevel = np0.currLevelNum

        if gGlobalSyncTable.randomizeObj then
            math.randomseed(gGlobalSyncTable.seed)
            randomize_all_objects()
        end
    end
end

local function level_init()
    set_skybox_color(0, math.random(10, 255))
    set_skybox_color(1, math.random(10, 255))
    set_skybox_color(2, math.random(10, 255))
    set_fog_color(0, math.random(10, 255))
    set_fog_color(1, math.random(10, 255))
    set_fog_color(2, math.random(10, 255))

    if levelTable[np0.currCourseNum] and not levelsToSkip[np0.currLevelNum] and gGlobalSyncTable.randomizeLvl then
        if gPlayerSyncTable[0].entryLevel == nil then
            gPlayerSyncTable[0].entryLevel = np0.currLevelNum
            gPlayerSyncTable[0].entryCourse = np0.currCourseNum
        end
        local newLevel = levelTable[np0.currCourseNum]
        if gPlayerSyncTable[0].entryLevel ~= newLevel then
            warp_to_level(newLevel, 1, np0.currActNum)
        end
        set_override_skybox(skyboxTable[math.random(1, #skyboxTable)] or -1)
        set_background_music(0, musicTable[math.random(1, #musicTable)], 0)
    else
        gPlayerSyncTable[0].entryLevel = nil
        gPlayerSyncTable[0].entryCourse = nil
    end

    on_warp()
end

local function break_box_in_water(o)
    local m = nearest_mario_state_to_object(o)
    if m.action == ACT_WATER_PUNCH and obj_check_hitbox_overlap(o, m.marioObj) and o.oAction == 2 then
        o.oExclamationBoxForce = true
        o.oAction = 3
        o.oExclamationBoxForce = false
        network_send_object(o, true)
    end
end

function invis_pipe(o)
    if obj_has_model_extended(o, E_MODEL_NONE) ~= 0 then
        obj_set_model_extended(o, E_MODEL_TRANS_PIPE)
    end
end

local function chest_number_init(o) --* code from the star number
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj_set_billboard(o)
end

local function chest_number_loop(o)
    local chest = o.parentObj
    if chest == nil or chest.activeFlags == ACTIVE_FLAG_DEACTIVATED then
        obj_mark_for_deletion(o)
        return
    end

    obj_set_pos(o, chest.header.gfx.pos.x, chest.header.gfx.pos.y + 200.0 * chest.header.gfx.scale.y, chest.header.gfx.pos.z)
    obj_set_angle(o, 0, 0, 0)
    obj_scale(o, 1.0)
    o.oAnimState = chest.oBehParams2ndByte
    o.oBehParams2ndByte = o.oAnimState
    o.header.gfx.node.flags = chest.header.gfx.node.flags
end

local id_bhvChestNumber = hook_behavior(nil, OBJ_LIST_DEFAULT, true, chest_number_init, chest_number_loop, "bhvRandomizerChestNumber")

local function spawn_chest_number(o)
    local chestNumber = obj_get_first_with_behavior_id(id_bhvStarNumber)
    local sanityDepth = 0
    while chestNumber do
        sanityDepth = sanityDepth + 1
        if sanityDepth >= 10000 then break end
        if not chestNumber or chestNumber.parentObj == o then
            break
        end
        chestNumber = obj_get_next_with_same_behavior_id(chestNumber)
    end

    -- If not, spawn a number
    if not chestNumber and o then
        spawn_non_sync_object(id_bhvChestNumber, E_MODEL_NUMBER, o.oPosX, o.oPosY, o.oPosZ, function (cNum)
            chestNumber = cNum
        end)
    end
    if chestNumber and o then
        chestNumber.parentObj = o
        chestNumber.activeFlags = chestNumber.activeFlags | ACTIVE_FLAG_INITIATED_TIME_STOP -- to make sure it's updated even during time stop
    end
end

local function treasure_chest_bottom(o)
    if o.oTimer <= 0 and o.oAction <= 0 then
        randomize(o)
        local floorHeight = find_floor_height(o.oPosX, o.oPosY, o.oPosZ)
        o.oPosY = floorHeight
        spawn_chest_number(o)
    end
end

local function treasure_chest_top(o)
    if o.oTimer <= 0 and o.oAction <= 0 then
        obj_copy_pos_and_angle(o, o.parentObj)
        obj_set_parent_relative_pos(o, 0, 102, -77)
        obj_build_relative_transform(o)
    end
end

local function mario_update(m)
    if m.playerIndex ~= 0 then return end
    for_each_object_with_behavior(id_bhvHiddenStarTrigger, function (o)
        spawn_non_sync_object(id_bhvSparkleSpawn, E_MODEL_SPARKLES, o.oPosX, o.oPosY, o.oPosZ, nil)
    end)
    for_each_object_with_behavior(id_bhvFirePiranhaPlant, function (o)
        if o.oBehParams2ndByte > 0 then
            spawn_non_sync_object(id_bhvSparkleSpawn, E_MODEL_SPARKLES, o.oPosX, o.oPosY, o.oPosZ, nil)
        end
    end)
    for_each_object_with_behavior(id_bhvTreasureChestBottom, treasure_chest_bottom)
    for_each_object_with_behavior(id_bhvTreasureChestTop, treasure_chest_top)
    for_each_object_with_behavior(id_bhvExclamationBox, break_box_in_water)
    for_each_object_with_behavior(id_bhvWarpPipe, invis_pipe)
    if gGlobalSyncTable.starRequirement > gMarioStates[0].numStars and np0.currLevelNum == LEVEL_BITS then
        warp_to_castle(np0.currLevelNum)
        djui_chat_message_create("You don't have the requirement yet! (Stars needed: "..gGlobalSyncTable.starRequirement..")")
    end
end

function seq_load(player, seq)
    if player ~= SEQ_PLAYER_SFX then
        return musicTable[math.random(1, #musicTable)]
    end
end

local function on_death()
    if gPlayerSyncTable[0].entryLevel then
        if not warp_to_castle(gPlayerSyncTable[0].entryLevel) then
            warp_to_level(gPlayerSyncTable[0].entryLevel, 1, 0)
        end
        gMarioStates[0].health = 0x880
        gPlayerSyncTable[0].entryLevel = nil
        gPlayerSyncTable[0].entryCourse = nil
    end
end

local function on_pause_exit(toCastle)
    if not toCastle then
        if gPlayerSyncTable[0].entryLevel then
            if not warp_to_castle(gPlayerSyncTable[0].entryLevel) then
                warp_to_level(gPlayerSyncTable[0].entryLevel, 1, 0)
            end
            gMarioStates[0].health = 0x880
            gPlayerSyncTable[0].entryLevel = nil
            gPlayerSyncTable[0].entryCourse = nil
        end
    end
end

local function on_screen_transition(trans)
    if trans == WARP_TRANSITION_FADE_INTO_MARIO then
        if gPlayerSyncTable[0].entryLevel then
            if not warp_to_castle(gPlayerSyncTable[0].entryLevel) then
                warp_to_level(gPlayerSyncTable[0].entryLevel, 1, 0)
            end
            gMarioStates[0].health = 0x880
            gPlayerSyncTable[0].entryLevel = nil
            gPlayerSyncTable[0].entryCourse = nil
        end
    end
end

hook_event(HOOK_ON_SCREEN_TRANSITION, on_screen_transition)
hook_event(HOOK_ON_SEQ_LOAD, seq_load)
hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_LEVEL_INIT, level_init)
hook_event(HOOK_ON_WARP, on_warp)
hook_event(HOOK_ON_SYNC_VALID, on_warp)
hook_event(HOOK_ON_PAUSE_EXIT, on_pause_exit)
hook_event(HOOK_ON_DEATH, on_death)

PACKET_SEED_CHANGE = 1

local function on_seed_change(data)
    local m = gMarioStates[0]
    currArea  = 0
    currLevel = 0
    gPlayerSyncTable[0].entryLevel = nil
    gPlayerSyncTable[0].entryCourse = nil
    warp_to_level(gLevelValues.entryLevel, 1, 0)
    djui_popup_create("Host changed the seed from "..gGlobalSyncTable.seed.." to "..data.seed, 2)
    gGlobalSyncTable.seed = data.seed
    applyShuffle()
    gMarioStates[0].health = 0x880
    --set_override_skybox(skyboxTable[get_skybox()] or -1)
end

local sPacketTable = {
    [PACKET_SEED_CHANGE] = on_seed_change
}

function network_send_include_self(reliable, data)
    network_send(reliable, data)
    if sPacketTable[data.id] then
        sPacketTable[data.id](data)
    end
end

local function on_packet_receive(data)
    if sPacketTable[data.id] then
        sPacketTable[data.id](data)
    end
end

hook_event(HOOK_ON_PACKET_RECEIVE, on_packet_receive)

local function seed_command(msg)
    local seed = tonumber(msg) or 0
    if seed ~= gGlobalSyncTable.seed then
        network_send_include_self(true, {id = PACKET_SEED_CHANGE, seed = seed})
    end
    return true
end

if network_is_server() then
    hook_chat_command("seed", "[number] sets the seed", seed_command)
end

local threshold = false

local function on_mods_loaded()
    if not threshold then
        gPlayerSyncTable[0].entryLevel = nil
        gPlayerSyncTable[0].entryCourse = nil
        threshold = true
    end

    if currHack == "vanilla" then
        set_painting_texture()
    end
end

hook_event(HOOK_ON_SYNC_VALID, on_mods_loaded)

local function on_hud_render_behind()
    djui_hud_set_resolution(RESOLUTION_N64)

    if not djui_is_playerlist_open() then return end

    djui_hud_set_font(FONT_TINY)

    local scale = 0.4
    local lineHeight = 14 * scale
    local boxPadding = 4

    local maxWidth = 0
    local playerCount = 0

    for i = 0, MAX_PLAYERS - 1 do
        if gNetworkPlayers[i].connected then
            local nameWidth = djui_hud_measure_text(gNetworkPlayers[i].name) * scale
            local levelWidth = djui_hud_measure_text("Entry Level: " .. (get_level_name(gPlayerSyncTable[i].entryCourse or 0, gPlayerSyncTable[i].entryLevel or 0, 1) or "Castle")) * scale
            maxWidth = math.max(maxWidth, nameWidth, levelWidth)
            playerCount = playerCount + 1
        end
    end

    local x = 30
    local y = 50
    local boxWidth = maxWidth + (boxPadding * 2)
    local boxHeight = (playerCount * (lineHeight * 2)) + (boxPadding * 2)

    djui_hud_set_color(0, 0, 0, 150)
    djui_hud_render_rect(x - boxPadding, y - boxPadding, boxWidth, boxHeight)

    djui_hud_set_color(255, 255, 255, 255)
    for i = 0, MAX_PLAYERS - 1 do
        if gNetworkPlayers[i].connected then
            djui_hud_print_text(gNetworkPlayers[i].name, x, y, scale)
            djui_hud_print_text("Entry Level: "..(get_level_name(gPlayerSyncTable[i].entryCourse or 0, gPlayerSyncTable[i].entryLevel or 0, 1) or "Castle"), x, y + lineHeight, scale)
            y = y + (lineHeight * 2)
        end
    end
end

hook_event(HOOK_ON_HUD_RENDER_BEHIND, on_hud_render_behind)